/*
  Copyright (C) 2004 Fons Adriaensen <fons.adriaensen@skynet.be>
    
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "styles.h"


struct colors   Colors;
struct fonts    Fonts;
X_button_style  Bst0, Bst1;
X_textln_style  Tst1;

   
void init_styles (X_display *disp, X_resman *xrm)
{
    Colors.black = disp->blackpixel ();
    Colors.white = disp->whitepixel ();
    Colors.spect_bg = disp->alloc_color (xrm->get (".color.bg",   "#ece8dc"), Colors.white);
    Colors.spect_fg = disp->alloc_color (xrm->get (".color.fg",   "black"),   Colors.black);
    Colors.spect_ds = disp->alloc_color (xrm->get (".color.ds",   "gray70"),  Colors.black);
    Colors.spect_ls = disp->alloc_color (xrm->get (".color.ls",   "white"),   Colors.white);
    Colors.spect_gr = disp->alloc_color (xrm->get (".color.gr",   "gray80"),  Colors.white);
    Colors.spect_sc = disp->alloc_color (xrm->get (".color.sc",   "black"),   Colors.black);
    Colors.spect_gb = disp->alloc_color (xrm->get (".color.gb",   "white"),   Colors.white);
    Colors.spect_g1 = disp->alloc_color (xrm->get (".color.g1",   "blue"),    Colors.black);
    Colors.spect_g2 = disp->alloc_color (xrm->get (".color.g2",   "gray50"),  Colors.black);
    Colors.spect_an = disp->alloc_color (xrm->get (".color.an",   "red"),     Colors.black);
    Colors.spect_mk = disp->alloc_color (xrm->get (".color.mk",   "red"),     Colors.black);
    Colors.spect_fo = disp->alloc_color (xrm->get (".color.fo",   "white"),   Colors.white);
    Colors.spect_ca = disp->alloc_color (xrm->get (".color.ca",   "red"),     Colors.black);
    Colors.butt_c0  = disp->alloc_color (xrm->get (".color.bc0",  "#e0d8d0"), Colors.white);
    Colors.butt_c1  = disp->alloc_color (xrm->get (".color.bc1",  "orange"),  Colors.white);
    Colors.butt_c2  = disp->alloc_color (xrm->get (".color.bc2",  "yellow"),  Colors.white);
    Colors.butt_fg  = disp->alloc_color (xrm->get (".color.bfg",  "black"),   Colors.black);

    Fonts.button = disp->alloc_font (xrm->get (".font.bu", "-*-lucida-medium-r-normal-sans-*-120-*-*-*-*-*-1"));
    Fonts.scales = disp->alloc_font (xrm->get (".font.sc", "-*-lucida-medium-r-normal-sans-*-120-*-*-*-*-*-1"));
    Fonts.annot  = disp->alloc_font (xrm->get (".font.an", "-*-lucida-bold-r-normal-sans-*-120-*-*-*-*-*-1"));

    Bst0.font = Fonts.button;
    Bst0.color.col0   = Colors.butt_c0;
    Bst0.color.col1   = Colors.butt_c2;
    Bst0.color.text   = Colors.butt_fg;
    Bst0.color.shadow.parc = Colors.spect_bg;
    Bst0.color.shadow.lite = Colors.spect_ls;
    Bst0.color.shadow.dark = Colors.spect_ds;
    Bst0.size.x = 17;
    Bst0.size.y = 17;
    Bst0.type = X_button_style::RAISED;

    Bst1.font = Fonts.button;
    Bst1.color.col0   = Colors.butt_c0;
    Bst1.color.col1   = Colors.butt_c1;
    Bst1.color.text   = Colors.butt_fg;
    Bst1.color.shadow.parc = Colors.spect_bg;
    Bst1.color.shadow.lite = Colors.spect_ls;
    Bst1.color.shadow.dark = Colors.spect_ds;
    Bst1.size.x = 60;
    Bst1.size.y = 17;
    Bst1.type = X_button_style::RAISED | X_button_style::LED;

    Tst1.font = Bst1.font;
    Tst1.color.normal.bgnd = Colors.spect_bg;
    Tst1.color.normal.text = Colors.spect_fg;
    Tst1.color.focus.bgnd  = Colors.spect_fo;
    Tst1.color.focus.text  = Colors.spect_fg;
    Tst1.color.focus.caret = Colors.spect_ca;
    Tst1.color.shadow.lite = Colors.spect_ls;
    Tst1.color.shadow.dark = Colors.spect_ds;
}

